#pragma once

using namespace System;
using namespace System::ComponentModel;
using namespace System::Collections;
using namespace System::Diagnostics;


namespace EncapsTest {

	/// <summary>
	/// Summary for Fader
	/// </summary>
	public ref class Fader :  public System::Windows::Forms::UserControl
	{
	public:
		Fader(int id)
		{
			InitializeComponent();
			//
			//TODO: Add the constructor code here
			//
         FaderID = id;
		}
		Fader(System::ComponentModel::IContainer ^container)
		{
			/// <summary>
			/// Required for Windows.Forms Class Composition Designer support
			/// </summary>

			container->Add(this);
			InitializeComponent();
		}

	protected:
		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		~Fader()
		{
			if (components)
			{
				delete components;
			}
		}
   private: 
      int FaderID;  // index of this instance
   public:
      delegate void dgFader(int FaderID);
      dgFader^ dgEqValueChanged;
      dgFader^ dgNumericUpDown1_ValueChanged;
      dgFader^ dgNumericUpDown2_ValueChanged;
      dgFader^ dgCheckBox1_CheckedChanged;
      dgFader^ dgButton1_Click;
      dgFader^ dgButton2_Click;
   private: System::Windows::Forms::TextBox^  textBox1;
   public: System::Windows::Forms::Button^  button2;        // should be left private with property declaration access ???
   private: System::Windows::Forms::TrackBar^  trackBar1;
   public: System::Windows::Forms::Button^  button1;
   public: System::Windows::Forms::NumericUpDown^  numericUpDown1;
   public: System::Windows::Forms::CheckBox^  checkBox1;
   public: System::Windows::Forms::NumericUpDown^  numericUpDown2;


      property String^ Anno {String^ get() {return textBox1->Text;}        // proto interfaces - real world would be handling processed info...
                           void set(String^ Anno){textBox1->Text = Anno;}}
      property int EqValue {int get() {return trackBar1->Value;}
                           void set(int EqValue){trackBar1->Value = EqValue;}}


   protected: 
	private:
		/// <summary>
		/// Required designer variable.
		/// </summary>
		System::ComponentModel::Container ^components;

#pragma region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		void InitializeComponent(void)
		{
         this->textBox1 = (gcnew System::Windows::Forms::TextBox());
         this->button2 = (gcnew System::Windows::Forms::Button());
         this->trackBar1 = (gcnew System::Windows::Forms::TrackBar());
         this->button1 = (gcnew System::Windows::Forms::Button());
         this->numericUpDown1 = (gcnew System::Windows::Forms::NumericUpDown());
         this->checkBox1 = (gcnew System::Windows::Forms::CheckBox());
         this->numericUpDown2 = (gcnew System::Windows::Forms::NumericUpDown());
         (cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->trackBar1))->BeginInit();
         (cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->numericUpDown1))->BeginInit();
         (cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->numericUpDown2))->BeginInit();
         this->SuspendLayout();
         // 
         // textBox1
         // 
         this->textBox1->Location = System::Drawing::Point(3, 4);
         this->textBox1->Name = L"textBox1";
         this->textBox1->Size = System::Drawing::Size(68, 20);
         this->textBox1->TabIndex = 15;
         // 
         // button2
         // 
         this->button2->Location = System::Drawing::Point(44, 189);
         this->button2->Name = L"button2";
         this->button2->Size = System::Drawing::Size(21, 21);
         this->button2->TabIndex = 21;
         this->button2->Text = L"Y";
         this->button2->UseVisualStyleBackColor = true;
         this->button2->Click += gcnew System::EventHandler(this, &Fader::button2_Click);
         // 
         // trackBar1
         // 
         this->trackBar1->Location = System::Drawing::Point(18, 29);
         this->trackBar1->Maximum = 20;
         this->trackBar1->Name = L"trackBar1";
         this->trackBar1->Orientation = System::Windows::Forms::Orientation::Vertical;
         this->trackBar1->Size = System::Drawing::Size(42, 149);
         this->trackBar1->TabIndex = 16;
         this->trackBar1->TickStyle = System::Windows::Forms::TickStyle::Both;
         this->trackBar1->Value = 10;
         this->trackBar1->ValueChanged += gcnew System::EventHandler(this, &Fader::trackBar1_ValueChanged);
         // 
         // button1
         // 
         this->button1->Location = System::Drawing::Point(9, 189);
         this->button1->Name = L"button1";
         this->button1->Size = System::Drawing::Size(21, 21);
         this->button1->TabIndex = 20;
         this->button1->Text = L"X";
         this->button1->UseVisualStyleBackColor = true;
         this->button1->Click += gcnew System::EventHandler(this, &Fader::button1_Click);
         // 
         // numericUpDown1
         // 
         this->numericUpDown1->Location = System::Drawing::Point(9, 226);
         this->numericUpDown1->Name = L"numericUpDown1";
         this->numericUpDown1->Size = System::Drawing::Size(56, 20);
         this->numericUpDown1->TabIndex = 17;
         this->numericUpDown1->ValueChanged += gcnew System::EventHandler(this, &Fader::numericUpDown1_ValueChanged);
         // 
         // checkBox1
         // 
         this->checkBox1->AutoSize = true;
         this->checkBox1->Location = System::Drawing::Point(9, 295);
         this->checkBox1->Name = L"checkBox1";
         this->checkBox1->Size = System::Drawing::Size(56, 17);
         this->checkBox1->TabIndex = 19;
         this->checkBox1->Text = L"Active";
         this->checkBox1->UseVisualStyleBackColor = true;
         this->checkBox1->CheckedChanged += gcnew System::EventHandler(this, &Fader::checkBox1_CheckedChanged);
         // 
         // numericUpDown2
         // 
         this->numericUpDown2->Location = System::Drawing::Point(9, 261);
         this->numericUpDown2->Name = L"numericUpDown2";
         this->numericUpDown2->Size = System::Drawing::Size(58, 20);
         this->numericUpDown2->TabIndex = 18;
         this->numericUpDown2->ValueChanged += gcnew System::EventHandler(this, &Fader::numericUpDown2_ValueChanged);
         // 
         // Fader
         // 
         this->BorderStyle = System::Windows::Forms::BorderStyle::Fixed3D;
         this->Controls->Add(this->textBox1);
         this->Controls->Add(this->button2);
         this->Controls->Add(this->trackBar1);
         this->Controls->Add(this->button1);
         this->Controls->Add(this->numericUpDown1);
         this->Controls->Add(this->checkBox1);
         this->Controls->Add(this->numericUpDown2);
         this->Name = L"Fader";
         this->Size = System::Drawing::Size(75, 323);
         (cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->trackBar1))->EndInit();
         (cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->numericUpDown1))->EndInit();
         (cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->numericUpDown2))->EndInit();
         this->ResumeLayout(false);
         this->PerformLayout();

      }
#pragma endregion
   private: System::Void trackBar1_ValueChanged(System::Object^  sender, System::EventArgs^  e);
private: System::Void button1_Click(System::Object^  sender, System::EventArgs^  e);
private: System::Void button2_Click(System::Object^  sender, System::EventArgs^  e);
private: System::Void numericUpDown1_ValueChanged(System::Object^  sender, System::EventArgs^  e);
private: System::Void numericUpDown2_ValueChanged(System::Object^  sender, System::EventArgs^  e);
private: System::Void checkBox1_CheckedChanged(System::Object^  sender, System::EventArgs^  e);
};
}
